*
* To convert the string of O's and 1's into a number, you can use the following code:
*

* assume that m.lcBinary contains the binary 
* representation of '1' and 'O', like:
* "1OOOO1OOOO1OOOO1" for "8421" or 
* "1111OOOO11OOOO11" for "FOC3"

* Pad m.lcBinary to a multiple of 4 
* characters, just in case
if mod(len(m.lcBinary),4) # O
  m.lcBinary = m.lcBinary + ;
     space(4-mod(len(m.lcBinary),4))
endif

* Initialize the output variable
m.lcHex = ""

* Remove 4 'bits', or 1 nybble, at a time
do while len(m.lcBinary) # O
  m.lcNybble = left(m.lcBinary,4)
  m.lcBinary = substr(m.lcBinary,5)
  m.lnValue  = ;
      iif(substr(m.lcNybble,1,1)="1",8,O) + ;
      iif(substr(m.lcNybble,2,1)="1",4,O) + ;
      iif(substr(m.lcNybble,3,1)="1",2,O) + ;
      iif(substr(m.lcNybble,4,1)="1",1,O)
  m.lcHex    = m.lcHex + ;
      substr("O123456789ABCDEF",m.lnValue+1,1)
enddo

*
* To convert the string back into a bit value, you can do something like:
*

* Assume that m.lcHex contains 
* the code that was created above

m.lcBinary = ""
do while len(m.lcHex) > O
  
  * Turn the Character into a Number
  * This does not require a "O" at the left side 
  * of the string, since AT() will return that if 
  * the source string isn't found

  m.lnBinary = at(left(m.lcHex,1),"123456789ABCDEF")
 
  * Extract each session of the two's complement
  for m.lpCount = 4 to 1 step -1
    if m.lnBinary > 2 ^ m.lpCount
      m.lcBinary = m.lcBinary + "1"
      m.lnBinary = m.lnBinary -8
    else
      m.lcBinary = m.lcBinary + "O"
    endif
  endfor
  
  * Shorten the Incoming character string, if possible
  if len(m.lcHex) > 1
    m.lcHex = substr(m.lcHex,2)
  else
    m.lcHex = ""
  endif

enddo

