*-----------------------------------------------------------------
* Program Name: PRINTSCR.PRG (based on an idea by Mike Childers)
*       Author: Art Bergquist
*         Date: April 6, 1998
*      Purpose: Print Screen utility
*
*  DO PrintScr WITH .T.
*		or
*  1.	Press <PrintScreen> or <Alt+PrintScreen> for the
*     screen you want to capture
*  2.	DO PrintScr
*-----------------------------------------------------------------

LPARAMETERS tlAutoScreenPrint
LOCAL lnSelect

IF tlAutoScreenPrint
   * "Press" <PrintScreen> or <Alt+PrintScreen> for the user
   DECLARE INTEGER keybd_event IN Win32API INTEGER,		;
					INTEGER, INTEGER, INTEGER
   VK_SNAPSHOT = 44

   * Copy the active application window to the clipboard
   * (equivalent to <Alt+PrintScreen>)
   =keybd_event(VK_SNAPSHOT, 0, 0, 0)
ENDIF

lnSelect = SELECT()

DEFINE WINDOW PrintScr FROM 500, 500 TO 600, 600
ACTIVATE WINDOW PrintScr

* Ensure that a PrintScreen cursor does not already exist
USE IN IIF(USED('PrintScreen'), 'PrintScreen', 0)

CREATE CURSOR PrintScreen (ScreenPrint G, Notes M)
SELECT PrintScreen
APPEND BLANK

* <Ctrl-V} = Paste the contents of the Windows clipboard into the *            ScreenPrint general field
* <Ctrl-W> = Save changes to and close the ScreenPrint general
*            field
KEYBOARD '{Ctrl+V}{Ctrl+W}' PLAIN CLEAR
MODIFY GENERAL ScreenPrint WINDOW PrintScr
IF EMPTY(ScreenPrint)							
   && i.e., No OLE object in the General field
   =MessageBox('Nothing in the Windows clipboard to print!', ;
			0 + 48, _Screen.Caption)
ELSE
   * PrintScr was designed to be run from either a VFP application 
   * or the Command Window
   DO FORM PrintScr		&& Note: PrintScr form is Modal
ENDIF

USE IN PrintScreen

RELEASE WINDOW PrintScr

SELECT (lnSelect)			&& Restore to the original work area

